<?php
	/*=======================================================================
	 * copyright (c) AL-Design Works 
	 * http://cms.al-design.jp/
	 * Υե CMS Designer ΰǤ
	 * ܤ饤󥹵ˤĤƤϥ֥Ȥ򻲾ȤƤ
	 *=======================================================================
	 */

    require_once( dirname(__FILE__) . "/manager.text.php.inc" );
    require_once( dirname(__FILE__) . "/manager.int.php.inc" );
    require_once( dirname(__FILE__) . "/manager.file.php.inc" );
    require_once( dirname(__FILE__) . "/manager.list.php.inc" );
    require_once( dirname(__FILE__) . "/manager.menu.php.inc" );
    require_once( dirname(__FILE__) . "/manager.date.php.inc" );
    require_once( dirname(__FILE__) . "/manager.separator.php.inc" );
    require_once( dirname(__FILE__) . "/manager.geolocation.php.inc" );
	

    /* --------------------------------------------------------------------
     * եϹ饹
     * 
     */ 
	class EntryItemFactory
	{
		/* ----------------------------------------------------------------
		 * ŬڤʥեϹܤ롣
		 * $xmlSchemaData : б륹DataXMLǡ
		 */
		function createEntryItem( $xmlSchemaData, $entryName, $entryId )
		{
            $type = $xmlSchemaData->get_attribute( "type" );
			
			switch ( $type )
			{
				case 'textarea' :
				case 'text' :
					$item = new TextEntryItem( $xmlSchemaData, $entryName, $entryId );
					break;
				
				case 'int' :
					$item = new IntEntryItem( $xmlSchemaData, $entryName, $entryId );
					break;
				
				case 'img' :
				case 'file' :
					$item = new FileEntryItem( $xmlSchemaData, $entryName, $entryId );
					break;
				
				case 'menu' :
					$item = new MenuEntryItem( $xmlSchemaData, $entryName, $entryId );
					break;
				
				case 'list' :
					$item = new ListEntryItem( $xmlSchemaData, $entryName, $entryId );
					break;
				
				case 'datetime' :
				case 'date' :
				case 'time' :
				case 'year' :
				case 'month' :
				case 'entrydate' :
					$item = new DateEntryItem( $xmlSchemaData, $entryName, $entryId );
					break;
					
				case 'separator' :
					$item = new SeparatorEntryItem( $xmlSchemaData, $entryName, $entryId );
					break;
				
				case 'geolocation' :
					$item = new GeoLocationEntryItem( $xmlSchemaData, $entryName, $entryId );
					break;
					
				default :
					cmsd_abort_proc( 'invalid type of schema data element : ' . "'$type'" );
									
			}
			
			return $item;
		}
	}

?>