<?php
	/*=======================================================================
	 * copyright (c) AL-Design Works 
	 * http://cms.al-design.jp/
	 * Υե CMS Designer ΰǤ
	 * ܤ饤󥹵ˤĤƤϥ֥Ȥ򻲾ȤƤ
	 *=======================================================================
	 */

	require_once( dirname(__FILE__) . "/app.php.inc" );
	require_once( dirname(__FILE__) . "/xmlutil.php.inc" );

	
	/* -----------------------------------------------------------------
	 * ȥԽå饹
	 * ---------------------------------------------------------------*/
	class EditingEntryLock
	{
		/* 饹 */
		
		// å
		function CatchLock( $entryName, $entryId, $userId )
		{
			$lock = new EditingEntryLock();
			$lock->entryName = $entryName;
			$lock->entryId = $entryId;
			
			// entryname.entryid.*.lock ¸ߤ뤫ɤĴ٤
			$alreadyLocked = glob( App::createEntryLockFilePath( $entryName, $entryId, '*' ) );
			
			if ( $alreadyLocked )
			{
				// (ʬޤ)ïˤäƥåƤ
				
				// å롣
				$lockFilePath = $alreadyLocked[0];
				$lock->load( $lockFilePath );	
				
				// ʬΥåä顢ǽ򹹿롣
				if ( $lock->isOwner( $userId ) )
				{
					$lock->touch();
				}
				
				//print "alredy locked.";
				
			}
			else
			{
				// ޤïˤåƤʤä
				
				// åե롣
				$lockFilePath = App::createEntryLockFilePath( $entryName, $entryId, $userId );
				$fp = fopen( $lockFilePath, 'w' );
				fclose( $fp );
				
				// å롣
				$lock->load( $lockFilePath );
				
				//print "locked now.";
			}
			
			return $lock;
			
		}
		
		// å椫
		function IsLocked( $entryName, $entryId, $userId )
		{
			return file_exists( App::createEntryLockFilePath( $entryName, $entryId, $userId ) );
		}
		
		// å
		function RelaseLock( $entryName, $entryId, $userId )
		{

			// åʤ顢åե롣
			if ( EditingEntryLock::IsLocked( $entryName, $entryId, $userId ) )
			{
				unlink( App::createEntryLockFilePath( $entryName, $entryId, $userId ) );
			}
		}
		
		// å
		function ForceLock( $entryName, $entryId, $userId )
		{
			// ߤΥå֤Ū˲롣
			$files = glob( App::createEntryLockFilePath( $entryName, $entryId, '*' ) );
			if ( $files )
			{
				foreach( $files as $lockFile )
				{
					unlink( $lockFile );
				}
			}
			
			// å롣
			EditingEntryLock::CatchLock( $entryName, $entryId, $userId );
		}
		
		// 桼å
		function ReleaseLocksByUser( $userId )
		{
			$files = glob( App::createEntryLockFilePath( '*', '*', $userId ) );
			if ( $files )
			{
				foreach( $files as $lockFile )
				{
					unlink( $lockFile );
				}			
			}
			
		}
		
		
		/* 󥹥󥹥 */
		var $ownerUserId = '';
		var $lastUpdate = null;
		var $entryName = '';
		var $entryId = '';
		
		// åʡ
		function isOwner( $userId )
		{
			return ( $this->ownerUserId == $userId );
		}
		
		// åե뤫åɤ߹ࡣ
		function load( $lockFilePath )
		{
			// ե̾ʬ򤷤ƺǸƤ
			// 
			$lockFileName = basename( $lockFilePath );
			
			$tokens = explode( '.', $lockFileName );
			array_pop( $tokens );							// .lock
			$this->ownerUserId = array_pop( $tokens );		// userId
			$this->entryId = array_pop( $tokens );			// entryId
			$this->entryName = array_pop( $tokens );		// entryName
			
			// ǽ
			$this->lastUpdate = filemtime( $lockFilePath );
			
		}
		
		// å򹹿롣
		function touch()
		{
			// ǽ򹹿
			$lockFilePath = App::createEntryLockFilePath( $this->entryName, $this->entryId, $this->ownerUserId );
			touch( $lockFilePath );
			
			// ǽ
			$this->lastUpdate = filemtime( $lockFilePath );
			
		}
		
	}
	
	/* -----------------------------------------------------------------
	 * 饹
	 * ---------------------------------------------------------------*/
	class LoginManager
	{
		/* 饹 */
		function Logout()
		{
			unset ( $_SESSION['autheduser'] );
			
			// 桼ȥѥ̾򥯥å롣
			$timeout = time() - 60 * 60;		// 1ʶŪ˲ˤ
			$path = '/';
			$domain = $_SERVER['SERVER_NAME'];
			setcookie( 'cmsd_param1', '', $timeout, $path, $domain );
			setcookie( 'cmsd_param2', '', $timeout, $path, $domain );
			
		}
		
		function IsAuthed()
		{
			return isset( $_SESSION['autheduser'] );
		}
		
		function GetAuthedUser()
		{
			return $_SESSION['autheduser'];
		}
		
		function Login( $userId, $password )
		{
			$user = SiteUser::AuthUser( $userId, $password );
			
			if ( is_null( $user ) )
			{
				// ¸ߤʤ桼ʤΤǡ
				return false;
			}
			else
			{
				// ƥкȤơΥåڤΥ
				session_regenerate_id();
				
				// 
				$_SESSION['autheduser'] = $user;
				
				// 桼ȥѥ̾򥯥å¸롣
				$timeout = time() + 60 * 60 * 24 * 30;		// 1
				$path = '/';
				$domain = $_SERVER['SERVER_NAME'];
				setcookie( 'cmsd_param1', $userId, $timeout, $path, $domain );
				setcookie( 'cmsd_param2', $password, $timeout, $path, $domain );

				return true;
			}
		}		
	}
	
	
	/* -----------------------------------------------------------------
	 * 桼󥯥饹
	 * ---------------------------------------------------------------*/
	class SiteUser
	{
		/* 饹 */
		function AuthUser( $userId, $password )
		{
			// ͤΥå
			if ( SiteUser::IsErrorUserId( $userId ) or SiteUser::IsErrorPassword( $password ) )
			{
				return null;
			}
			
			
			$user = new SiteUser( $userId );
			if ( $user->isNew )
			{
				return null;
			}
			else
			{
				if ( $user->Auth( $password ) )
				{
					return $user;
				}
				else
				{
					return null;
				}
			}
		}
		
		function UserExists( $userId )
		{
			$user = new SiteUser( $userId );
			if ( $user->isNew )
			{
				return null;
			}
			else
			{
				return $user;
			}
		}
		
		function LoadAllUsers()
		{
			// 桼Users.Configɤ߹ࡣ
			if ( ! file_exists( App::getUsersConfigFilePath() ) )
			{
				cmsd_abort_proc('users.config.xml¸ߤޤ');
			}
			
			$xmlDocUsers = domxml_open_file( App::getUsersConfigFilePath() );
			$xpath = $xmlDocUsers->xpath_new_context();
			$xmlUserArr = $xpath->xpath_eval( "/users/user" );
			
			$userArr = array();
			foreach( cmsd_get_nodeset( $xmlUserArr ) as $xmlUser )
			{
				$user = new SiteUser();
				$user->LoadFromXMLNode( $xmlUser );
				
				$userArr[] = $user;
				
			}
			
			return $userArr;
		}
		
		function Delete( $userIdArr )
		{
			// Ǥʤ硢ǤĤѴ롣
			if ( ! is_array($userIdArr) )
			{
				$userIdArr = array( $userIdArr );
			}

			// ǧںѥ桼ID롣
			$user = LoginManager::GetAuthedUser();
			$authedUserId = $user->getUserId();
			
			// 桼Users.Configɤ߹ࡣ
			if ( ! file_exists( App::getUsersConfigFilePath() ) )
			{
				cmsd_abort_proc('users.config.xml¸ߤޤ');
			}
			
			$xmlDocUsers = domxml_open_file( App::getUsersConfigFilePath() );
			$xmlUsersRoot = $xmlDocUsers->document_element();
			$xpath = $xmlDocUsers->xpath_new_context();
			
			foreach ( $userIdArr as $userId )
			{
				// ʬȤΥ桼ʤ褦ˤ롣
				if ( $userId != $authedUserId )
				{
					// userǤ򸡺ơ롼Ǥ롣
					$xmlUserArr = $xpath->xpath_eval( "/users/user[@id='" . $userId . "']" );
					
					if ( !empty($xmlUserArr->nodeset) )
					{
						$xmlUsersRoot->remove_child( $xmlUserArr->nodeset[0] );
					}
				}
			}
			
			$xmlDocUsers->dump_file( App::getUsersConfigFilePath(), false, true );
						
		}
		
		
		function IsErrorUserId( $userId )
		{
			// 桼IDĹå
			if ( strlen( $userId ) < 3 || strlen( $userId ) > 20 )
			{
				return "桼ID3ʸʾ塢20ʸʲϤƲ";
			}
			
			// 桼IDʸå(ȾѱѿΤߵ)
			if ( ! mb_eregi( '^[a-zA-Z0-9_-]+$', $userId ) )
			{
				return "桼IDˤȾѱѿΤ߻ѤǤޤ";
			}
			
			return false;
		}
		
		
		function IsErrorPassword( $newPassword, $role = null )
		{
			// Ĺå
			if ( strlen( $newPassword ) > 20 )
			{
				return "ѥɤĹ20ʸʲϤƲ";
			}
			
			// ѥɤϡƥԤξ4ʸʾɬס
			if ( $role == 'administrator' && strlen( $newPassword ) < 4 )
			{
				return "ƥԤΥѥɤĹ4ʸʾɬפǤ";
			}
			
			// ʸå
			// ʸå(ȾѱѿΤߵ)
			if ( ! mb_eregi( '^[a-zA-Z0-9_-]*$', $newPassword ) )
			{
				return "ѥɤˤȾѱѿΤ߻ѤǤޤ";
			}
			
			return false;
			
		}
		
		
		/* 󥹥󥹥 */
		
		var $userId = "";				// 桼ID
		var $password = "";			// ѥɡʰŹ沽
		var $role = "publisher";		// 
		var $isNew = true;				// Υ桼桼ʥե뤫ɤ߹ޤ줿ʤ¸桼
		
		function SiteUser( $userId = null )
		{
			if ( $userId )
			{
				$this->Load( $userId );
			}
		}
		
		function getUserId()
		{
			return $this->userId;
		}
		
		function setUserId( $newUserId )
		{
			$this->userId = $newUserId;
		}
		
		function setPassword( $newUncreptedPassword )
		{
			$this->password = crypt( $newUncreptedPassword, 'cm' );
		}
		
		function setRole( $newRole )
		{
			$this->role = $newRole;
		}

		function getRole()
		{
			return $this->role;
		}
		
		function isAdministrator()
		{
			return ( $this->role == 'administrator' );
		}
		
		function isPublisher()
		{
			return ( $this->role == 'publisher' );
		}
		
		function Auth( $inputPassword )
		{
			if ( $this->password == crypt( $inputPassword, 'cm') )
			{
				return true;
			}
			else
			{
				return false;
			}
		}
		
		function LoadFromXMLNode( &$xmlUser )
		{
			$this->userId = $xmlUser->get_attribute('id');
			$this->password = $xmlUser->get_attribute('password');
			$this->role = $xmlUser->get_attribute('role');
			
			// ѥɤʤ顢Ź沽롣
			if ( strlen( $this->password ) <= 0 )
			{
				$this->password = crypt( '', 'cm' );
			}
			
			// ̾å
			if ( $this->role != 'administrator' && $this->role != 'publisher' )
			{
				cmsd_abort_proc('users.config.xml̤role̾ꤵƤޤ');
			}
			
			// ¸桼
			$this->isNew = false;
		}
		
		function Load( $userId )
		{
			// 桼Users.Configɤ߹ࡣ
			if ( ! file_exists( App::getUsersConfigFilePath() ) )
			{
				cmsd_abort_proc('users.config.xml¸ߤޤ');
			}
			
			$xmlDocUsers = domxml_open_file( App::getUsersConfigFilePath() );
			$xpath = $xmlDocUsers->xpath_new_context();
			$xmlUserArr = $xpath->xpath_eval( "/users/user[@id='$userId']" );
			
			if ( !empty($xmlUserArr->nodeset) )
			{
				// 桼¸ߤСξ롣
				$xmlUser = $xmlUserArr->nodeset[0];
				
				$this->LoadFromXMLNode( $xmlUser );
				
			}
			else
			{
				// 桼¸ߤʤС桼Ȥƽ롣
				
				$this->userId = $userId;					// ꤵ줿桼ID
				$this->password = crypt( '', 'cm' );		// ʰŹ沽
				$this->role = 'publisher';					//  : publisher
				
				// 桼
				$this->isNew = true;
			}
			
		}
		
		function Save()
		{
			// 桼Users.Configɤ߹ࡣ
			$usersconfigfilepath = App::getUsersConfigFilePath();
			if ( ! file_exists( $usersconfigfilepath ) )
			{
				cmsd_abort_proc( "'$usersconfigfilepath'¸ߤޤ" );
			}
			
			// 桼ե뤬񤭹߲ǽå롣
			if ( ! is_writable( $usersconfigfilepath ) )
			{
				cmsd_abort_proc( "'$usersconfigfilepath'򹹿Ǥޤ󡣥եΥѡߥå606666˰ʾˤʤäƤ뤫ǧƤ" );
			}
			
			$xmlDocUsers = domxml_open_file( App::getUsersConfigFilePath() );
						
		   	$xpath = $xmlDocUsers->xpath_new_context();
		   	$xmlUserArr = $xpath->xpath_eval( "/users/user[@id='" . $this->userId . "']" );
			
			if ( !empty($xmlUserArr->nodeset) )
			{
				if ( $this->isNew )
				{
					// 桼ʤΤˡեƱ桼¸ߤΤϤ
					cmsd_abort_proc("桼οɲä˼Ԥޤ桼'" . $this->userId . "'ϴ¸ߤޤ");
				}
				
				// 桼¸ߤСߤΥ󥹥Ƥꤹ롣
				$xmlUser = $xmlUserArr->nodeset[0];
				$xmlUser->set_attribute('password', $this->password );
				$xmlUser->set_attribute('role', $this->role );

			}
			else
			{
				if ( ! $this->isNew )
				{
					// 桼ʤΤˡեˤΥ桼¸ߤʤΤϤ
					cmsd_abort_proc("桼ι˼Ԥޤ桼'". $this->userId . "'¸ߤޤ");
				}
				
				$xmlUser = $xmlDocUsers->create_element('user');
				$xmlUser->set_attribute('id', $this->userId );
				$xmlUser->set_attribute('password', $this->password );
				$xmlUser->set_attribute('role', $this->role );
				
				$xmlUserRoot = $xmlDocUsers->document_element();
				$xmlUserRoot->append_child( $xmlUser );
								
				// ⤦ɲäΤǡ桼ǤϤʤʤ롣
				$this->isNew = false;
			}
			
			$xmlDocUsers->dump_file( App::getUsersConfigFilePath(), false, true );

		}
		
		function DispStatus()
		{
			print "---------------------<br />\n";
			print 'userId = ' . $this->userId . "<br />\n";
			print 'password = ' . $this->password . "<br />\n";
			print 'role = ' . $this->role . "<br />\n";
			print 'isNew = ' . ( $this->isNew ? 'true' : 'false' ) . "<br />\n";
			print "---------------------<br />\n";
			
		}
		
	}

	/* -----------------------------------------------------------------
	 * 桼Խ̥饹
	 * ---------------------------------------------------------------*/	
	class EditUserListForm
	{
	
		/* ----------------------------------------------------------------
		 * 󥹥ȥ饯
		 */		
		function EditUserListForm()
		{
		}
		
		/* ----------------------------------------------------------------
		 * ꥯȤνƤӽФ᥽åɡ
		 */		
		function procRequest()
		{
			// Admin¤å
			$authedUser = LoginManager::GetAuthedUser();
			if ( $authedUser->isAdministrator() )
			{
				// ƤӽФʤactionԤʤ
				if ( ! isset( $_GET['p'] ) )
				{
					// ȽꡧɤǤʤΤߡƼԤ
					if ( ! ReloadToken::isReload() )
					{
				
						// ƽ¹
						switch ( getPOSTParam( 'action' ) )
						{
							case 'delete' :
								$itemlist = $_POST[ 'items' ];
								EditUserListForm::DeleteItems( $itemlist );
								break;
						}
					}
				}
				
				// 桼ꥹȤ
				$userArr = SiteUser::LoadAllUsers();
			}
			else
			{
				// admin¤̵ϡΥ桼ꥹȤϤ
				$userArr = array();
			}
			
			// ɥȡ򿷤ȯԤ롣
			ReloadToken::newToken();
			
			// ɽ
			print( $this->renderHTMLXML( $userArr, LoginManager::GetAuthedUser() ) );	
			
		}
		
		
		/* ----------------------------------------------------------------
		 * [饹᥽å]
		 * ꤷȥID롣
		 * $entryName : ȥ̾
		 * $itemlist : ȥID
		 */
		function DeleteItems( $itemlist )
		{
			// 桼롣
			SiteUser::Delete( $itemlist );
		}
		
		/* ----------------------------------------------------------------
		 * ̤衣XMLǲ̾XSLTȤä̤Ϥ롣
		 */		
		function renderHTMLXML( $userArr, $authedUser )
		{
			// HTML	
			// DOM
			// 롼ȥΡ'users'
			$xmlDocOutput = domxml_new_doc( '1.0' );
			$xmlOutputRoot = $xmlDocOutput->add_root( 'edituserlistform' );
			$xmlOutputRoot->set_attribute('autheduserid', $authedUser->getUserId() );
			$xmlOutputRoot->set_attribute('autheduserrole', $authedUser->getRole() );
			
			// ƥ桼ϥΡɤ˲ä롣
			foreach( $userArr as $user )
			{
				// DOM˥ȥ꣱ʬξ񤭽Ф
				$xmlOutputUser = $xmlDocOutput->create_element('user');
				$xmlOutputUser->set_attribute('id', $user->getUserId() );
				$xmlOutputUser->set_attribute('role', $user->getRole() );
								
				$xmlOutputRoot->append_child( $xmlOutputUser );

			}
			
			// ReloadTokenν
			ReloadToken::embedToXmlDoc( $xmlDocOutput );
			
			// HTMLλ
			// XSLѴ
			//$strFormHTML = ADXslt::process( $xmlDocOutput, dirname(__FILE__) . "/entryeditor.xsl" );
			$strFormHTML = CommonActionUtil::XsltEntryEditor( $xmlDocOutput );
			
			return $strFormHTML;			
			
		}

		
	}
	
	
	/* -----------------------------------------------------------------
	 * 桼Խ̥饹
	 * ---------------------------------------------------------------*/	
	class EditUserForm
	{
		var $userId = '';
		var $newPassword = '';
		var $passwordSetting = false;
		var $role = '';
		var $isNew = true;
		
		var $errorMessage = '';
		var $criticalError = false;
		
		/* ----------------------------------------------------------------
		 * 󥹥ȥ饯
		 */		
		function EditUserForm( $userId )
		{
			// ʸѴ
			$userId = strtolower( $userId );
			
			if ($userId == 'new')
			{
				// 桼κ
				$user = new SiteUser();
			}
			else
			{
				// ¸桼Υɡ
				$user = new SiteUser( $userId );
			}
			
			// ̥եɤ
			if ( ! is_null( $user ) )
			{
				//$user->DispStatus();
				$this->userId = $user->getUserId();
				$this->role = $user->getRole();
				$this->isNew = $user->isNew;
				$this->newPassword = '';
				$this->passwordSetting = false;
			}
			
		}
		
		/* ----------------------------------------------------------------
		 * ꥯȤνƤӽФ᥽åɡ
		 */		
		function procRequest()
		{
			// 顼򥯥ꥢ
			$this->errorMessage = '';
			$this->criticalError = false;
			
			// IDϽ:ʤ
			$nextFormId = null;
			
			// ǧںѤߥ桼
			$authedUser = LoginManager::GetAuthedUser();
			if ( $authedUser->isAdministrator() )
			{
				// Admin¥ꡣ
				if ( $authedUser->isAdministrator() )
				{
					// ƤӽФʤactionԤʤ
					if ( ! isset( $_GET['p'] ) )
					{
						// ȽꡧɤǤʤΤߡƼԤ
						if ( ! ReloadToken::isReload() )
						{
						
							// ƽ¹
							switch ( getPOSTParam( 'action' ) )
							{
								case 'save' :
									$this->update();
									$this->save();
									
									if ( ! $this->errorMessage )
									{
										// 顼̵С1β̤زܡ
										$nextFormId = 'edituserlist';
									}
									break;
			 				}
		 				}
		 			}
				}
			}
			else
			{
				// Admin¤̵
				$this->criticalError = true;
				$this->errorMessage = 'ˤϥƥԸ¤ɬפǤ';
			}			
			
			if ( $nextFormId == null )
			{
				// ɥȡ򿷤ȯԤ롣
				ReloadToken::newToken();
				
				// ɽ
				print( $this->renderHTMLXML() );
			}
			
			return $nextFormId;
			
		}
		
		function update()
		{
			if ( $this->isNew )
			{
				$this->userId = strtolower( $_POST['userid'] );
			}
			
			$this->role = ( strtolower( $_POST['role'] ) == 'administrator' ) ? 'administrator' : 'publisher';
			
			$this->passwordSetting = ( isset( $_POST['passwordsetting'] ) );
			if ($this->passwordSetting)
			{
				$this->newPassword = $_POST['newpassword'];
			}
		}
		
		
		/* ----------------------------------------------------------------
		 * ԽΥ桼ե¸롣
		 */
		function save()
		{
			
			// ----------------------------------------------------------------
			// ϥå
			
			if ( $this->isNew )
			{
				// 桼IDĹåʸå
				$errorMessage = SiteUser::IsErrorUserId( $this->userId );
				if ( $errorMessage )
				{
					$this->errorMessage = $errorMessage;
					return;
				}
				
				/*
				// 桼IDĹå
				if ( strlen( $this->userId ) < 3 || strlen( $this->userId ) > 20 )
				{
					$this->errorMessage = "桼ID3ʸʾ塢20ʸʲϤƲ";
					return;
				}
				
				// 桼IDʸå(ȾѱѿΤߵ)
				if ( ! eregi( '^[a-z0-9\-_]+$', $this->userId ) )
				{
					$this->errorMessage = "桼IDˤȾѱѿΤ߻ѤǤޤ";
					return;
				}
				*/
				
				// 桼ID¸ߥå
				if ( SiteUser::UserExists( $this->userId ) )
				{
					$this->errorMessage = "Υ桼IDϴ˻ȤƤޤ";
					return;
				}
				
			}
			else
			{
				// 桼ID¸ߥå
				if ( ! SiteUser::UserExists( $this->userId )  )
				{
					$this->errorMessage = "Υ桼¸ߤޤ";
					return;
				}
			}
			
			// ѥɤϥå
			if ( $this->passwordSetting )
			{
				// ѥɤĹåʸå
				$errorMessage = SiteUser::IsErrorPassword( $this->newPassword, $this->role );
				if ( $errorMessage )
				{
					$this->errorMessage = $errorMessage;
					return;
				}
				
				/*
				// Ĺå
				if ( strlen( $this->newPassword ) > 20 )
				{
					$this->errorMessage = "ѥɤĹ20ʸʲϤƲ";
					return;
				}
				
				// ѥɤϡƥԤξ4ʸʾɬס
				if ( $this->role == 'administrator' && strlen( $this->newPassword ) < 4 )
				{
					$this->errorMessage = "ƥԤΥѥɤĹ4ʸʾɬפǤ";
					return;
				}
				
				// ʸå
				// ʸå(ȾѱѿΤߵ)
				if ( ! eregi( '^[a-zA-Z0-9\-_]+$', $this->userId ) )
				{
					$this->errorMessage = "桼IDˤȾѱѿΤ߻ѤǤޤ";
					return;
				}				
				*/
				
			}
			
			// ----------------------------------------------------------------
			// 桼֥Ȥ
			
			$user = new SiteUser( $this->userId );
			
			// ѥ
			if ( $this->passwordSetting )
			{
				$user->setPassword( $this->newPassword );
			}
			
			// 
			$user->setRole( $this->role );
			
			// ¸
			$user->save();
			
		}
		
		/* ----------------------------------------------------------------
		 * ̤衣XMLǲ̾XSLTȤä̤Ϥ롣
		 */		
		function renderHTMLXML()
		{
			// HTML	
			// DOM
			// 롼ȥΡ'users'
			$xmlDocOutput = domxml_new_doc( '1.0' );
			$xmlOutputRoot = $xmlDocOutput->add_root( 'edituserform' );
			
			// ̿Ū顼ե饰
			$xmlOutputRoot->set_attribute('criticalerror', $this->criticalError ? 'true' : 'false');
			
			// ̿Ū顼ǤʤСƤꤹ롣
			if ( ! $this->criticalError )
			{
				
				// 桼ID
				$xmlOutputRoot->set_attribute('userid', $this->userId);
			
				// ѥ
				$xmlOutputRoot->set_attribute('newpassword', $this->newPassword);
			
				// 
				$xmlOutputRoot->set_attribute('role', $this->role);
				
				// ե饰
				$xmlOutputRoot->set_attribute('isnew', $this->isNew ? 'true' : 'false');
				
			}

			// 顼åнϤ롣
			if ( $this->errorMessage )
			{
				$xmlOutputErrorMessage = $xmlDocOutput->create_element('errormessage');
				$xmlOutputErrorMessage->set_content( fileconv( $this->errorMessage )	 );
				$xmlOutputRoot->append_child( $xmlOutputErrorMessage );
			}
			
			// ReloadTokenν
			ReloadToken::embedToXmlDoc( $xmlDocOutput );
			
			// HTMLλ
			// XSLѴ
			//$strFormHTML = ADXslt::process( $xmlDocOutput, dirname(__FILE__) . "/entryeditor.xsl" );
			$strFormHTML = CommonActionUtil::XsltEntryEditor( $xmlDocOutput );
			
			return $strFormHTML;			
			
		}

		
	}	
	


?>