<?xml version="1.0" encoding="UTF-8" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
  <xsl:output method="html" encoding="EUC-JP" omit-xml-declaration="yes" />
  <xsl:template match="/entrylist ">
    <xsl:for-each select="entry">
    
      <div class="link">
        <div class="sitename"><xsl:value-of select="sitename" /></div>
        <div class="url">
          <a href="{url}"><xsl:value-of select="url" /></a>
        </div>
        <div class="genre">種類：
          <xsl:if test="genre='search'">検索エンジン</xsl:if>
          <xsl:if test="genre='newsmag'">ニュース・読み物</xsl:if>
          <xsl:if test="genre='tools'">便利サイト</xsl:if>
　        <xsl:if test="genre='others'">その他</xsl:if>
        </div>
        <div class="description">
          <xsl:value-of select="description" disable-output-escaping="yes" />
        </div>
        <div class="lastupdate">最終更新日：<xsl:value-of select="@date" />
        </div>
      </div>
  
    </xsl:for-each>
  </xsl:template>
</xsl:stylesheet>